<?php 
############################################################## 
## MOD Title: Approve_Mod
## MOD Author: Aceman < phpbbmods@synace.com > (Mike Dawidowicz) http://www.synace.com
## MOD Description: Designate a forum for moderation by admins & chosen moderators. 
##	Option to setup Topic, Topic Edit, Post, Post Edit, User-Specific moderation.
##	Auto-Approve users or replies to chosen topics.
##	Notify users on post approval, selected moderators on new posts, via private messaging or email.
## MOD Version: 1.0.8
############################################################## 
## For Security Purposes, Please Check: http://www.phpbb.com/mods/ for the 
## latest version of this MOD. Downloading this MOD from other sites could cause malicious code 
## to enter into your phpBB Forum. As such, phpBB will not offer support for MOD's not offered 
## in our MOD-Database, located at: http://www.phpbb.com/mods/ 
############################################################## 

define('IN_PHPBB', true); 

$phpbb_root_path = './'; 
$approve_schemas = $phpbb_root_path . 'approve_mod_install/';

include($phpbb_root_path . 'extension.inc'); 
include($phpbb_root_path . 'common.'.$phpEx); 

$forum_url = append_sid("index.$phpEx");
$phpbb_approve_mod_topic = "http://www.phpbb.com/phpBB/viewtopic.php?t=122005";

// 
// Start session management 
// 
$userdata = session_pagestart($user_ip, PAGE_INDEX); 
init_userprefs($userdata); 
// 
// End session management 
// 

include($phpbb_root_path.'language/lang_' . $board_config['default_lang'] . '/lang_admin.'.$phpEx);

$approve_dbms = array(
	'mysql'=> array(
		'LABEL'			=> 'MySQL 3.x',
		'SCHEMA'		=> 'mysql', 
		'DELIM'			=> ';',
		'DELIM_BASIC'	=> ';',
		'COMMENTS'		=> 'remove_remarks'
	), 
	'mysql4' => array(
		'LABEL'			=> 'MySQL 4.x',
		'SCHEMA'		=> 'mysql', 
		'DELIM'			=> ';', 
		'DELIM_BASIC'	=> ';',
		'COMMENTS'		=> 'remove_remarks'
	), 
	'postgres' => array(
		'LABEL'			=> 'PostgreSQL 7.x',
		'SCHEMA'		=> 'postgres', 
		'DELIM'			=> ';', 
		'DELIM_BASIC'	=> ';',
		'COMMENTS'		=> 'remove_comments'
	), 
	'mssql' => array(
		'LABEL'			=> 'MS SQL Server 7/2000',
		'SCHEMA'		=> 'mssql', 
		'DELIM'			=> 'GO', 
		'DELIM_BASIC'	=> ';',
		'COMMENTS'		=> 'remove_comments'
	),
	'msaccess' => array(
		'LABEL'			=> 'MS Access [ ODBC ]',
		'SCHEMA'		=> '', 
		'DELIM'			=> '', 
		'DELIM_BASIC'	=> ';',
		'COMMENTS'		=> ''
	),
	'mssql-odbc' =>	array(
		'LABEL'			=> 'MS SQL Server [ ODBC ]',
		'SCHEMA'		=> 'mssql', 
		'DELIM'			=> 'GO',
		'DELIM_BASIC'	=> ';',
		'COMMENTS'		=> 'remove_comments'
	)
);

if( !$userdata['session_logged_in'] ) 
{ 
	redirect(append_sid("login.$phpEx?redirect=approve_mod_mysql_install.$phpEx", true));
} 

if( $userdata['user_level'] != ADMIN ) 
{ 
   message_die(GENERAL_MESSAGE, 'You are not authorised to access this page'); 
} 
$dbms = ( isset($dbms) ) ? $dbms : $HTTP_POST_VARS['dbms'];
$page_title = 'Approve_MOD 1.0.9 - SQL Installation'; 
if ( intval($HTTP_POST_VARS['go']) != 1 )
{
	if ( empty($dbms) )
	{
		include($phpbb_root_path . 'includes/page_header.'.$phpEx); 


		$dbms_select = '<select name="dbms">';
		while (list($dbms_name, $details) = @each($approve_dbms))
		{
			$selected = ($dbms_name == $dbms) ? 'selected="selected"' : '';
			$dbms_select .= '<option value="' . $dbms_name . '">' . $details['LABEL'] . '</option>';
		}
		$dbms_select .= '</select>';

print<<<PRINTEND

		<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">
		  <tr>
			<th class="thHead">Installing database tables</th>
		  </tr>
			<tr>
				<td class="row1" align="center"><form action="" method="post"><span class="gen"><br />Please choose the database connection type.
		<br /><br />
		$dbms_select
		<br />
		<input type="submit" name="confirm" value="Continue" class="mainoption" /></span></form></td>
			</tr>
		</table>

PRINTEND;

		include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
	}
	else
	{
		include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

		$table_type = " ".$approve_dbms[$dbms]['LABEL'];
print<<<PRINTEND
		<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">
		  <tr>
			<th class="thHead">Installing database tables</th>
		  </tr>
			<tr>
				<td class="row1" align="center"><form action="" method="post"><span class="gen"><br />Are you sure you want to install the Approve_MOD$table_type tables?
		<br /><br />
		<input type="hidden" name="go" value="1">
		<input type="hidden" name="dbms" value="$dbms">
		<input type="submit" name="confirm" value="Yes" class="mainoption" />&nbsp;&nbsp;<input type="submit" name="cancel" value="No" class="liteoption" /></span></form></td>
			</tr>
		</table>

PRINTEND;

		include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
	}
}
else
{
	include($phpbb_root_path . 'includes/page_header.'.$phpEx); 

print<<<PRINTEND
	<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">
	  <tr>
		<th class="thHead">Installing database tables</th>
	  </tr>
	  <tr>
		<td>
		  <span class="genmed">
			<ul type="disc">

PRINTEND;
	if (!empty($dbms))
	{
		switch($dbms)
		{
			case 'msaccess':
			case 'mssql-odbc':
				$check_exts = 'odbc';
				$check_other = 'odbc';
				break;

			case 'mssql':
				$check_exts = 'mssql';
				$check_other = 'sybase';
				break;

			case 'mysql':
			case 'mysql4':
				$check_exts = 'mysql';
				$check_other = 'mysql';
				break;

			case 'postgres':
				$check_exts = 'pgsql';
				$check_other = 'pgsql';
				break;
		}

		if (!extension_loaded($check_exts) && !extension_loaded($check_other))
		{	
			?>
			<div class="genmed" align="center"><?php echo $lang['Install_No_Ext']; ?><br />
		  If you have any problems, please visit <a href="<?php echo $phpbb_approve_mod_topic; ?>" target="_new">phpbb.com (Approve_MOD Support Thread)</a> and ask for help.</div>
			<?php
			include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
			exit;
		}
	}

	$dbms_schema = $approve_schemas . $approve_dbms[$dbms]['SCHEMA'] . '_schema.sql';
	$dbms_basic = $approve_schemas . $approve_dbms[$dbms]['SCHEMA'] . '_basic.sql';

	$remove_remarks = $approve_dbms[$dbms]['COMMENTS'];;
	$delimiter = $approve_dbms[$dbms]['DELIM']; 
	$delimiter_basic = $approve_dbms[$dbms]['DELIM_BASIC']; 

	if ($dbms == 'msaccess')
	{
		?>
		<div class="genmed" align="center">Please check the documentation for how to add the tables to your existing MS-Access database.<br />
		  If you have any problems, please visit <a href="<?php echo $phpbb_approve_mod_topic; ?>" target="_new">phpbb.com (Approve_MOD Support Thread)</a> and ask for help.</div>
		<?php
		include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
		exit;	
	}
	else
	{
		// Load in the sql parser
		include($phpbb_root_path.'includes/sql_parse.'.$phpEx);

		// Ok we have the db info go ahead and read in the relevant schema
		// and work on building the table.. probably ought to provide some
		// kind of feedback to the user as we are working here in order
		// to let them know we are actually doing something.
		$sql_query = @fread(@fopen($dbms_schema, 'r'), @filesize($dbms_schema));
		$sql_query = preg_replace('/phpbb_/', $table_prefix, $sql_query);

		$sql_query = $remove_remarks($sql_query);
		$sql_query = split_sql_file($sql_query, $delimiter);

		for ($i = 0; $i < sizeof($sql_query); $i++)
		{
			if (trim($sql_query[$i]) != '')
			{
				if (!($result = $db->sql_query($sql_query[$i])))
				{
					$error = $db->sql_error();
	
					print('<li>' . nl2br(trim($sql_query[$i])) . '<br /><ul type="square"><li><font color="#FF0000"><b>Error:</b></font> ' . $error['message'] . '</li></ul></li><br />');
					$sql_error = true;
					break;
				}
				else
				{
					print('<li>' . nl2br(trim($sql_query[$i])) . '<br /><ul type="square"><li><font color="#00AA00"><b>Successfull</b></font></li></ul></li><br />');
				}
			}
		}

		if ( !$sql_error )
		{
			// Ok tables have been built, let's fill in the basic information
			$sql_query = @fread(@fopen($dbms_basic, 'r'), @filesize($dbms_basic));
			$sql_query = preg_replace('/phpbb_/', $table_prefix, $sql_query);

			$sql_query = $remove_remarks($sql_query);
			$sql_query = split_sql_file($sql_query, $delimiter_basic);

			for($i = 0; $i < sizeof($sql_query); $i++)
			{
				if (trim($sql_query[$i]) != '')
				{
					if (!($result = $db->sql_query($sql_query[$i])))
					{
						$error = $db->sql_error();

						print('<li>' . nl2br(trim($sql_query[$i])) . '<br /><ul type="square"><li><font color="#FF0000"><b>Error:</b></font> ' . $error['message'] . '</li></ul></li><br />');
						$sql_error = true;
						break;
					}
					else
					{
						print('<li>' . nl2br(trim($sql_query[$i])) . '<br /><ul type="square"><li><font color="#00AA00"><b>Successfull</b></font></li></ul></li><br />');
					}
				}
			}
		}
	}

print<<<PRINTEND
			</ul>
		  </span>
		</td>
	  </tr>
	  <tr>
		<td class="catBottom" height="28">&nbsp;</td>
	  </tr>
	</table>

	<br />
	<br />
PRINTEND;

	if ( !$sql_error )
	{
print<<<PRINTEND
	<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">
	  <tr>
		<th class="thHead">Installation complete</th>
	  </tr>
	  <tr>
		<td align="center">
		  <span class="genmed">Please delete this file and the install folder.<br />
		  If you have any problems, please visit <a href="{$phpbb_approve_mod_topic}" target="_new">phpbb.com (Approve_MOD Support Thread)</a> and ask for help.</span>
		</td>
	  </tr>
	  <tr>
		<td class="catBottom" height="28">&nbsp;</td>
	  </tr>
	</table>

PRINTEND;
	}
	else
	{
print<<<PRINTEND
	<table width="100%" cellspacing="1" cellpadding="2" border="0" class="forumline">
	  <tr>
		<th class="thHead">Error</th>
	  </tr>
	  <tr>
		<td align="center">
		  <span class="genmed">Please make sure your database doesn'nt have conflicting tables, data, and that you can properly connection, then try again.<br />
		  If you have any problems, please visit <a href="{$phpbb_approve_mod_topic}" target="_new">phpbb.com (Approve_MOD Support Thread)</a> and ask for help.</span>
		</td>
	  </tr>
	  <tr>
		<td class="catBottom" height="28">&nbsp;</td>
	  </tr>
	</table>

PRINTEND;
	}
	include($phpbb_root_path . 'includes/page_tail.'.$phpEx); 
}
?>
