/*
  Approve_Mod 1.0.9 - phpBB 2.0.6 MSSQL DB schema
*/

BEGIN TRANSACTION
GO

CREATE TABLE [phpbb_approve_forums] ( 
	[forum_id] [smallint] NOT NULL IDENTITY (1, 1) , 
	[enabled] [smallint] NOT NULL , 
	[approve_posts] [smallint] NOT NULL , 
	[approve_topics] [smallint] NOT NULL , 
	[approve_users] [smallint] NOT NULL , 
	[approve_poste] [smallint] NOT NULL , 
	[approve_topice] [smallint] NOT NULL , 
	[approve_notify] [smallint] NOT NULL , 
	[approve_notify_approval] [smallint] NOT NULL , 
	[approve_notify_type] [smallint] NOT NULL , 
	[approve_notify_message] [smallint] NOT NULL , 
	[approve_notify_message_len] [smallint] NOT NULL , 
	[approve_moderators] [varchar] (255)NOT NULL , 
	[approve_notify_posts] [smallint] NOT NULL , 
	[approve_notify_poste] [smallint] NOT NULL , 
	[approve_notify_topics] [smallint] NOT NULL , 
	[approve_notify_topice] [smallint] NOT NULL , 
	[forum_hide_unapproved_topics] [smallint] NOT NULL , 
	[forum_hide_unapproved_posts] [smallint] NOT NULL , 
) ON [PRIMARY]
GO

CREATE TABLE [phpbb_approve_posts] ( 
	[approval_id] [int] NOT NULL IDENTITY (1, 1), 
	[topic_id] [int] NOT NULL , 
	[post_id] [int] NOT NULL , 
	[is_topic] [smallint] NOT NULL , 
	[is_post] [smallint] NOT NULL , 
	[poster_id] [int] NOT NULL , 
) ON [PRIMARY]
GO

CREATE TABLE [phpbb_approve_topics] ( 
	[topic_id] [int] NOT NULL IDENTITY (1, 1) , 
	[approve_moderate] [smallint] NOT NULL , 
) ON [PRIMARY]
GO

CREATE TABLE [phpbb_approve_users] ( 
	[user_id] [int] NOT NULL IDENTITY (1, 1) , 
	[approve_moderate] [smallint] NOT NULL , 
) ON [PRIMARY]
GO

INSERT INTO phpbb_approve_users ( user_id, approve_moderate ) VALUES (-1, 1); 
Go 

ALTER TABLE [phpbb_approve_forums] WITH NOCHECK ADD
	CONSTRAINT [PK_phpbb_approve_forums] PRIMARY KEY  CLUSTERED
	(
		[forum_id]
	) ON [PRIMARY]
GO

ALTER TABLE [phpbb_approve_posts] WITH NOCHECK ADD
	CONSTRAINT [PK_phpbb_approve_posts] PRIMARY KEY CLUSTERED
	(
		[approval_id]
	) ON [PRIMARY]
GO

ALTER TABLE [phpbb_approve_topics] WITH NOCHECK ADD
	CONSTRAINT [PK_phpbb_approve_topics] PRIMARY KEY CLUSTERED
	(
		[topic_id]
	) ON [PRIMARY]
GO

ALTER TABLE [phpbb_approve_users] WITH NOCHECK ADD
	CONSTRAINT [PK_phpbb_approve_users] PRIMARY KEY CLUSTERED
	(
		[user_id]
	) ON [PRIMARY]
GO

ALTER TABLE [phpbb_approve_forums] WITH NOCHECK ADD
	CONSTRAINT [DF_phpbb_approve_forums_enabled] DEFAULT (0) FOR [enabled],
	CONSTRAINT [DF_phpbb_approve_forums_approve_posts] DEFAULT (0) FOR [approve_posts],
	CONSTRAINT [DF_phpbb_approve_forums_approve_topics] DEFAULT (0) FOR [approve_topics],
	CONSTRAINT [DF_phpbb_approve_forums_approve_users] DEFAULT (0) FOR [approve_users],
	CONSTRAINT [DF_phpbb_approve_forums_approve_poste] DEFAULT (0) FOR [approve_poste],
	CONSTRAINT [DF_phpbb_approve_forums_approve_topice] DEFAULT (0) FOR [approve_topice],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify] DEFAULT (0) FOR [approve_notify],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify_approval] DEFAULT (0) FOR [approve_notify_approval],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify_type] DEFAULT (0) FOR [approve_notify_type],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify_message] DEFAULT (0) FOR [approve_notify_message],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify_message_len] DEFAULT (500) FOR [approve_notify_message_len],
	CONSTRAINT [DF_phpbb_approve_forums_auth_attachments] DEFAULT (500) FOR [approve_notify_message_len],
	CONSTRAINT [DF_phpbb_approve_forums_approve_moderators] DEFAULT (0) FOR [approve_moderators],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify_posts] DEFAULT (0) FOR [approve_notify_posts],
	CONSTRAINT [DF_phpbb_approve_forums_approve_notify_poste] DEFAULT (0) FOR [approve_notify_poste],
	CONSTRAINT [DF_phpbb_approve_forums_approve_approve_notify_topics] DEFAULT (0) FOR [approve_notify_topics],
	CONSTRAINT [DF_phpbb_approve_forums_approve_approve_notify_topice] DEFAULT (0) FOR [approve_notify_topice],
	CONSTRAINT [DF_phpbb_approve_forums_approve_forum_hide_unapproved_topics] DEFAULT (0) FOR [forum_hide_unapproved_topics],
	CONSTRAINT [DF_phpbb_approve_forums_approve_forum_hide_unapproved_posts] DEFAULT (0) FOR [forum_hide_unapproved_posts]
GO

ALTER TABLE [phpbb_approve_posts] WITH NOCHECK ADD
	CONSTRAINT [DF_phpbb_approve_posts_topic_id] DEFAULT (0) FOR [topic_id],
	CONSTRAINT [DF_phpbb_approve_posts_post_id] DEFAULT (0) FOR [post_id],
	CONSTRAINT [DF_phpbb_approve_posts_is_topic] DEFAULT (0) FOR [is_topic],
	CONSTRAINT [DF_phpbb_approve_posts_is_post] DEFAULT (0) FOR [is_post],
	CONSTRAINT [DF_phpbb_approve_posts_poster_id] DEFAULT (0) FOR [poster_id]
GO

ALTER TABLE [phpbb_approve_topics] WITH NOCHECK ADD
	CONSTRAINT [DF_phpbb_approve_topics_approve_moderate] DEFAULT (0) FOR [approve_moderate]
GO

ALTER TABLE [phpbb_approve_users] WITH NOCHECK ADD
	CONSTRAINT [DF_phpbb_approve_users_approve_moderate] DEFAULT (0) FOR [approve_moderate]
GO

CREATE INDEX [IX_phpbb_approve_posts] ON [phpbb_approve_posts]([post_id], [topic_id]) ON [PRIMARY]
GO

COMMIT
GO