/*
  Approve_Mod 1.0.9 - phpBB 2.0.6 PostgreSQL DB schema
*/

CREATE SEQUENCE phpbb_approve_topics_approval_id_seq start 1 increment 1 maxvalue 2147483647 minvalue 1 cache 1;

/* --------------------------------------------------------
  Table structure for table phpbb_approve_forums
-------------------------------------------------------- */
CREATE TABLE phpbb_approve_forums (
  forum_id int4 unsigned DEFAULT '0' NOT NULL,
  enabled int DEFAULT '0' NOT NULL,
  approve_posts int DEFAULT '0' NOT NULL,
  approve_topics int DEFAULT '0' NOT NULL,
  approve_users int DEFAULT '0' NOT NULL,
  approve_poste int DEFAULT '0' NOT NULL,
  approve_topice int DEFAULT '0' NOT NULL,
  approve_notify int DEFAULT '0' NOT NULL,
  approve_notify_approval int DEFAULT '0' NOT NULL,
  approve_notify_type int DEFAULT '0' NOT NULL,
  approve_notify_message int DEFAULT '0' NOT NULL,
  approve_notify_message_len int2 NOT NULL default '500',
  approve_moderators varchar(255) DEFAULT '0' NOT NULL,
  approve_notify_posts int DEFAULT '0' NOT NULL,
  approve_notify_poste int DEFAULT '0' NOT NULL,
  approve_notify_topics int DEFAULT '0' NOT NULL,
  approve_notify_topice int DEFAULT '0' NOT NULL,
  forum_hide_unapproved_topics int DEFAULT '0' NOT NULL,
  forum_hide_unapproved_posts int DEFAULT '0' NOT NULL,
  CONSTRAINT phpbb_approve_forums_pkey PRIMARY KEY (forum_id)
);

/* --------------------------------------------------------
  Table structure for table phpbb_approve_posts
-------------------------------------------------------- */
CREATE TABLE phpbb_approve_posts (
  approval_id int4 DEFAULT nextval('phpbb_approve_topics_approval_id_seq'::text) NOT NULL,
  topic_id int4 unsigned DEFAULT '0' NOT NULL,
  post_id int4 unsigned DEFAULT '0' NOT NULL,
  is_topic int DEFAULT '0' NOT NULL,
  is_post int DEFAULT '0' NOT NULL,
  poster_id int4 DEFAULT '0' NOT NULL,
  CONSTRAINT phpbb_approve_posts_pkey PRIMARY KEY (approval_id)
);
CREATE INDEX post_id_phpbb_approve_posts_index ON phpbb_approve_posts (post_id);
CREATE INDEX topic_id_phpbb_approve_posts_index ON phpbb_approve_posts (topic_id);

/* --------------------------------------------------------
  Table structure for table phpbb_approve_topics
-------------------------------------------------------- */
CREATE TABLE phpbb_approve_topics (
  topic_id int4 unsigned DEFAULT '0' NOT NULL,
  approve_moderate int DEFAULT '0' NOT NULL,
  CONSTRAINT phpbb_approve_topics_pkey PRIMARY KEY (topic_id)
);

/* --------------------------------------------------------
  Table structure for table phpbb_approve_users
-------------------------------------------------------- */
CREATE TABLE phpbb_approve_users (
  user_id int4 DEFAULT '0' NOT NULL,
  approve_moderate int DEFAULT '0' NOT NULL,
  CONSTRAINT phpbb_approve_users_pkey PRIMARY KEY (user_id)
);

